package etu.sl213616;

import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

public class ConnexionController {

    @FXML
    private TextField nomField;  
    @FXML
    private PasswordField passwordField; 
    @FXML
    private Button validerButton;  
    private App2 appInstance;

    public void setAppInstance(App2 app) {
        this.appInstance = app;
    }

    @FXML
    private void initialize() {
        validerButton.setDisable(true);
        nomField.textProperty().addListener((observable, oldValue, newValue) -> actionLogin());
        passwordField.textProperty().addListener((observable, oldValue, newValue) -> actionPwd());
    }
    
    private void actionLogin() {
        if (isFormValid()) {
            validerButton.setDisable(false);  
        } else {
            validerButton.setDisable(true);  
        }
    }
    
    private void actionPwd() {
        if (isFormValid()) {
            validerButton.setDisable(false);  
        } else {
            validerButton.setDisable(true); 
        }
    }

    private boolean isFormValid() {
        return !nomField.getText().isEmpty() && !passwordField.getText().isEmpty();
    }

    @FXML
    private void validerConnexion() {
        String nom = nomField.getText();
        String password = passwordField.getText();

        if (nom.isEmpty() || password.isEmpty()) {
            appInstance.afficherMessage("Connexion annulée");
        } else {
            appInstance.afficherMessage("Connexion réussie de " + nom);
            appInstance.setConnexion(new Connexion(nom, password));  
        }

        fermerFenetre();
    }

    @FXML
    private void annulerConnexion() {
        appInstance.afficherMessage("Connexion annulée");
        fermerFenetre();
    }
    
    private void fermerFenetre() {
        ((Stage) nomField.getScene().getWindow()).close();  
    }
}
